// Copyright © 2017 Project Golan, all rights reserved.
#include "g_object.h"
#include "m_str.h"

#include <Doominati.h>

#include <stdio.h>

// Static Functions ----------------------------------------------------------|

//
// R_DrawPost
//
static DGE_Callback void R_DrawPost(ulfra delta)
{
   static char const *place = u8"地球軌道・朝";

   DGE_Texture_Bind(DGE_Texture_Get(s"@textures/Border.png"));
   DGE_Draw_Rectangle(0, 0, 960, 720);

   DGE_Font_Bind(DGE_Font_Get(s"myfont"));
   DGE_Draw_SetTextAlign(DGE_Align_Center);
   DGE_Draw_Text(760, 20, place);
   DGE_Draw_SetTextAlign(DGE_Align_Left);
   DGE_Draw_Text(585, 70, u8"ハイスコア\nスコア\n\n再試行回");
   DGE_Draw_SetTextAlign(DGE_Align_Right);
   DGE_Draw_Text(945, 70, M_StrFmt("%.15i\n%.15i\n\n%i", 0, 0, 5));
}

//
// G_Stage_Begin
//
static void G_Stage_Begin(unsigned stagenum)
{
   G_Player_Create(-200, 250);
}

// Extern Functions ----------------------------------------------------------|

//
// main
//
[[__extern("asm")]] DGE_Callback
void main(void)
{
   printf("\n=====================\n"
          u8"オミ：影響の目    1.0\n"
          u8"Copyright © 2017 Project Golan, all rights reserved.\n\n");

   DGE_Renderer_SetVirtualRes(960, 720);

   printf("Loading object function table...\n");
   G_ObjDef_Init();
   G_ObjDef_loadFunc(G_Player_Think);

   printf("Loading object definitions...\n");
   G_ObjDef_Load("objdefs.dod");

   printf("Creating fonts...\n");
   DGE_Font_Create(s"myfont", "fonts/base.ttf", 24);

   printf("Registering callbacks...\n");
   DGE_Callback_Register(DGE_CB_DrawPost, (DGE_CallbackType)R_DrawPost);

   printf("Ready.\n");

   G_Stage_Begin(1);
}

// EOF
